package com.echo.cis.util.validation;

import java.util.Date;

/*
 * ASookazian: http://www.seamframework.org/Community/SeamValidatorNotBeingExecuted
 */

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.intercept.BypassInterceptors;
import org.jboss.seam.log.Log;
import org.jboss.seam.log.Logging;

@Name("effectiveDateValidator")
@org.jboss.seam.annotations.faces.Validator
@BypassInterceptors
public class EffectiveDateValidator implements javax.faces.validator.Validator, java.io.Serializable {
	
   private static final long serialVersionUID = -4259611077820028265L;

   Log log = Logging.getLog(EffectiveDateValidator.class);
      
   private String cmpId;
   private String clientId;
      
   public void validate(FacesContext context, UIComponent cmp, Object value) throws ValidatorException {	   
	   if (value != null) {   
		   cmpId = cmp.getId();
		   log.info("validate(): cmpId = "+cmpId);
		   
		   clientId = cmp.getClientId(context);
		   log.info("validate(): clientId = "+clientId);
		   
		   Date effectiveDate = (Date)value;		   
		   Date today = new Date();
		   if (effectiveDate.before(today)) {
			   String errorString = effectiveDate + " is a date in the past.  Please enter today's date or a future date.";		   
			   throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_WARN, errorString, errorString));
		   }
	   }
   }
}
